#ifndef P11TESTS_H_
#define P11TESTS_H_

#include "pkcs11/pkcs11.h"

enum {
	P11_TESTS_NONE,
	P11_TESTS_INFO,
	P11_TESTS_WARN,
	P11_TESTS_FAIL
};

typedef void    (*P11TestsLogFunc)            (int level,
                                               const char *section,
                                               const char *message);

int             p11_tests_get_unexpected      (void);

void            p11_tests_set_unexpected      (int value);

int             p11_tests_get_write_session   (void);

void            p11_tests_set_write_session   (int value);

int             p11_tests_get_verbose         (void);

void            p11_tests_set_verbose         (int value);

int             p11_tests_load_config         (const char *config);

P11TestsLogFunc p11_tests_get_log_func        (void);

void            p11_tests_set_log_func        (P11TestsLogFunc func);

void            p11_tests_perform             (CK_FUNCTION_LIST_PTR module);

#endif /* P11TESTS_H_ */
